/*
 * AMC.c
 *
 * Code generation for function 'AMC'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "gjbf.h"
#include "AMC.h"
#include "gjbf_emxutil.h"
#include "log10.h"
#include "sum.h"
#include "power.h"
#include "mod.h"
#include "gjbf_data.h"
#include "blas.h"

/* Variable Definitions */
static emlrtRSInfo dd_emlrtRSI = { 8, "AMC",
  "E:\\micro array project\\Microphone Array\\beamform test\\AMC.m" };

static emlrtRSInfo ed_emlrtRSI = { 9, "AMC",
  "E:\\micro array project\\Microphone Array\\beamform test\\AMC.m" };

static emlrtRTEInfo g_emlrtRTEI = { 1, 34, "AMC",
  "E:\\micro array project\\Microphone Array\\beamform test\\AMC.m" };

static emlrtDCInfo m_emlrtDCI = { 8, 21, "AMC",
  "E:\\micro array project\\Microphone Array\\beamform test\\AMC.m", 1 };

static emlrtBCInfo j_emlrtBCI = { 1, 882, 8, 21, "b", "AMC",
  "E:\\micro array project\\Microphone Array\\beamform test\\AMC.m", 0 };

static emlrtDCInfo n_emlrtDCI = { 9, 19, "AMC",
  "E:\\micro array project\\Microphone Array\\beamform test\\AMC.m", 1 };

static emlrtBCInfo k_emlrtBCI = { 1, 882, 9, 19, "y", "AMC",
  "E:\\micro array project\\Microphone Array\\beamform test\\AMC.m", 0 };

/* Function Definitions */
void AMC(const emlrtStack *sp, const real_T b[882], const real_T y[14112],
         real_T n, real_T snrThresh, real_T snrRate, real_T snr[16], boolean_T
         amcInds[16], real_T mcAdapt[14112])
{
  int32_T i37;
  real_T x;
  int32_T i38;
  int32_T i39;
  int32_T i40;
  real_T b_data[882];
  int32_T b_size[1];
  int32_T loop_ub;
  emxArray_real_T *b_y;
  real_T tmp_data[882];
  int32_T tmp_size[1];
  emxArray_real_T *r2;
  emlrtStack st;
  st.prev = sp;
  st.tls = sp->tls;
  emlrtHeapReferenceStackEnterFcnR2012b(sp);
  covrtLogFcn(&emlrtCoverageInstance, 5U, 0);

  /*  update amcInd at snrRate time */
  covrtLogCond(&emlrtCoverageInstance, 5U, 0U, 0, false);
  if (covrtLogCond(&emlrtCoverageInstance, 5U, 0U, 1, b_mod(n, snrRate) == 0.0))
  {
    covrtLogMcdc(&emlrtCoverageInstance, 5U, 0U, 0, true);
    covrtLogIf(&emlrtCoverageInstance, 5U, 0U, 0, true);
    covrtLogBasicBlock(&emlrtCoverageInstance, 5U, 0);

    /* snr condition to adapt */
    x = (n - snrRate) + 1.0;
    if (x > n) {
      i37 = 0;
      i38 = 0;
    } else {
      if (x != (int32_T)muDoubleScalarFloor(x)) {
        emlrtIntegerCheckR2012b(x, &m_emlrtDCI, sp);
      }

      i37 = (int32_T)x;
      if (!((i37 >= 1) && (i37 <= 882))) {
        emlrtDynamicBoundsCheckR2012b(i37, 1, 882, &j_emlrtBCI, sp);
      }

      i37--;
      i38 = (int32_T)n;
    }

    x = (n - snrRate) + 1.0;
    if (x > n) {
      i39 = 0;
      i40 = 0;
    } else {
      if (x != (int32_T)muDoubleScalarFloor(x)) {
        emlrtIntegerCheckR2012b(x, &n_emlrtDCI, sp);
      }

      i39 = (int32_T)x;
      if (!((i39 >= 1) && (i39 <= 882))) {
        emlrtDynamicBoundsCheckR2012b(i39, 1, 882, &k_emlrtBCI, sp);
      }

      i39--;
      i40 = (int32_T)n;
    }

    b_size[0] = i38 - i37;
    loop_ub = i38 - i37;
    for (i38 = 0; i38 < loop_ub; i38++) {
      b_data[i38] = b[i37 + i38];
    }

    emxInit_real_T(sp, &b_y, 2, &g_emlrtRTEI, true);
    st.site = &dd_emlrtRSI;
    b_power(&st, b_data, b_size, tmp_data, tmp_size);
    i37 = b_y->size[0] * b_y->size[1];
    b_y->size[0] = i40 - i39;
    b_y->size[1] = 16;
    emxEnsureCapacity(sp, (emxArray__common *)b_y, i37, (int32_T)sizeof(real_T),
                      &g_emlrtRTEI);
    for (i37 = 0; i37 < 16; i37++) {
      loop_ub = i40 - i39;
      for (i38 = 0; i38 < loop_ub; i38++) {
        b_y->data[i38 + b_y->size[0] * i37] = y[(i39 + i38) + 882 * i37];
      }
    }

    emxInit_real_T(sp, &r2, 2, &g_emlrtRTEI, true);
    st.site = &ed_emlrtRSI;
    c_power(&st, b_y, r2);
    st.site = &dd_emlrtRSI;
    x = c_sum(&st, tmp_data, tmp_size);
    st.site = &ed_emlrtRSI;
    d_sum(&st, r2, snr);
    emxFree_real_T(&b_y);
    emxFree_real_T(&r2);
    for (i37 = 0; i37 < 16; i37++) {
      snr[i37] = x / snr[i37];
    }

    st.site = &dd_emlrtRSI;
    b_log10(&st, snr);

    /*  find which tracks adapt */
    for (i37 = 0; i37 < 16; i37++) {
      snr[i37] *= 10.0;
      amcInds[i37] = (snr[i37] > snrThresh);
    }
  } else {
    covrtLogMcdc(&emlrtCoverageInstance, 5U, 0U, 0, false);
    covrtLogIf(&emlrtCoverageInstance, 5U, 0U, 0, false);
  }

  covrtLogBasicBlock(&emlrtCoverageInstance, 5U, 1);
  for (i37 = 0; i37 < 16; i37++) {
    mcAdapt[((int32_T)n + 882 * i37) - 1] = !amcInds[i37];
  }

  emlrtHeapReferenceStackLeaveFcnR2012b(sp);
}

/* End of code generation (AMC.c) */
