/*
 * delaytracking.c
 *
 * Code generation for function 'delaytracking'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "gjbf.h"
#include "delaytracking.h"
#include "power.h"
#include "arweights.h"
#include "round1.h"
#include "error.h"
#include "any.h"
#include "sqrt.h"
#include "sum.h"
#include "isfinite.h"
#include "all.h"
#include "gjbf_data.h"
#include "blas.h"

/* Variable Definitions */
static emlrtRSInfo lb_emlrtRSI = { 26, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

static emlrtRSInfo mb_emlrtRSI = { 27, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

static emlrtRSInfo nb_emlrtRSI = { 28, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

static emlrtRSInfo ob_emlrtRSI = { 29, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

static emlrtRSInfo pb_emlrtRSI = { 31, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

static emlrtRSInfo qb_emlrtRSI = { 34, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

static emlrtRSInfo rb_emlrtRSI = { 35, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

static emlrtRSInfo sb_emlrtRSI = { 36, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

static emlrtRSInfo tb_emlrtRSI = { 39, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

static emlrtRSInfo ub_emlrtRSI = { 60, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

static emlrtRSInfo vb_emlrtRSI = { 63, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

static emlrtDCInfo e_emlrtDCI = { 84, 35, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m", 1
};

static emlrtBCInfo e_emlrtBCI = { -1, -1, 84, 35, "xPrev", "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m", 0
};

static emlrtDCInfo f_emlrtDCI = { 85, 11, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m", 1
};

static emlrtBCInfo f_emlrtBCI = { 1, 882, 85, 11, "x", "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m", 0
};

static emlrtECInfo b_emlrtECI = { -1, 84, 5, "delaytracking",
  "E:\\micro array project\\Microphone Array\\beamform test\\delaytracking.m" };

/* Function Definitions */
void delaytracking(const emlrtStack *sp, const real_T x[14112], const
                   emxArray_real_T *xPrev, real_T fs, const real_T spos[3],
                   const real_T mpos[48], real_T c, real_T iw, real_T XSF[14112],
                   real_T wghts[16])
{
  boolean_T b1;
  boolean_T bv8[14112];
  boolean_T dist[16];
  boolean_T guard1 = false;
  boolean_T tmp_data[14112];
  int32_T tmp_size[2];
  boolean_T bv9[3];
  real_T b_mpos[48];
  int32_T ixstart;
  real_T dv0[48];
  int32_T ix;
  real_T b_dist[16];
  boolean_T bv10[48];
  real_T mtmp;
  boolean_T exitg1;
  int32_T k;
  int32_T loop_ub;
  real_T xPrev_data[1764];
  int32_T i28;
  int32_T xPrev_size_idx_0;
  int32_T b_loop_ub;
  int32_T b_tmp_size[1];
  real_T b_tmp_data[1764];
  int32_T iv22[1];
  emlrtStack st;
  st.prev = sp;
  st.tls = sp->tls;
  b1 = false;
  covrtLogFcn(&emlrtCoverageInstance, 1U, 0);

  /* % delay tracking */
  /*   XSF = delaytracking(x, xPrev, fs, spos, mpos, c, iw) */
  /*  INPUT */
  /*  * |x|-each column response a mic track */
  /*  * |xPrev|-data from a previous window. This data allows for real data to be padded */
  /*    at the front of each shifted track .Simply zeros if no previous data       */
  /*  * |fs|- sampling rate (Hertz) */
  /*  * |spos| - 3x1 source location point (col vector) (meters) */
  /*  * |mpos| - column matrix of mic positions (meters) */
  /*  * |c| - speed of sound (meters/sec) */
  /*  * |iw| -(optional) if set to 1, the dsb will apply an inverse distance  */
  /*          weighting on the microphones, useful for near-field/immersive */
  /*          applications.  Any other value or its absense will result in */
  /*          the uniform weight dbs. */
  /* OUTPUT */
  /*  * |y| - delay tracking */
  /* % Function Declaration */
  /* % Argument Error Checking */
  covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 0, false);
  covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 0, false);
  covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 1, true);
  b_isfinite(x, bv8);
  st.site = &lb_emlrtRSI;
  all(&st, bv8, dist);
  if (!covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 2, b_all(dist))) {
    covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 0, true);
    covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 1, true);
    st.site = &mb_emlrtRSI;
    error(&st);
  } else {
    covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 0, false);
    covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 1, false);
    guard1 = false;
    if (covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 3, xPrev->size[0] == 0)) {
      guard1 = true;
    } else {
      covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 4, true);
      g_isfinite(xPrev, tmp_data, tmp_size);
      st.site = &nb_emlrtRSI;
      f_all(&st, tmp_data, tmp_size, dist);
      if (!covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 5, b_all(dist))) {
        guard1 = true;
      } else {
        covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 1, false);
        covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 2, false);
        covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 6, false);
        covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 7, true);
        covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 8, true);
        if ((!covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 9, c_isfinite(fs))) ||
            covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 10, fs <= 0.0)) {
          covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 2, true);
          covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 3, true);
          covrtLogBasicBlock(&emlrtCoverageInstance, 1U, 1);
          st.site = &pb_emlrtRSI;
          b_error(&st);
        } else {
          covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 2, false);
          covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 3, false);
          covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 11, false);
          covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 12, true);
          d_isfinite(spos, bv9);
          if (!covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 13, c_all(bv9))) {
            covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 3, true);
            covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 4, true);
            covrtLogBasicBlock(&emlrtCoverageInstance, 1U, 2);
            st.site = &qb_emlrtRSI;
            c_error(&st);
          } else {
            covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 14, false);
            covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 15, false);
            covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 16, false);
            covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 3, false);
            covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 4, false);
            covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 17, true);
            e_isfinite(mpos, bv10);
            st.site = &rb_emlrtRSI;
            d_all(&st, bv10, dist);
            if (!covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 18, b_all(dist)))
            {
              covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 4, true);
              covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 5, true);
              st.site = &sb_emlrtRSI;
              u_error(&st);
            } else {
              covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 19, false);
              covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 4, false);
              covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 5, false);
              covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 20, false);
              covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 21, true);
              covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 22, true);
              if ((!covrtLogCond(&emlrtCoverageInstance, 1U, 0U, 23, c_isfinite
                                 (c))) || covrtLogCond(&emlrtCoverageInstance,
                   1U, 0U, 24, c <= 0.0)) {
                covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 5, true);
                covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 6, true);
                covrtLogBasicBlock(&emlrtCoverageInstance, 1U, 3);
                st.site = &tb_emlrtRSI;
                e_error(&st);
              } else {
                covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 5, false);
                covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 6, false);
              }
            }
          }
        }
      }
    }

    if (guard1) {
      covrtLogMcdc(&emlrtCoverageInstance, 1U, 0U, 1, true);
      covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 2, true);
      st.site = &ob_emlrtRSI;
      n_error(&st);
    }
  }

  covrtLogBasicBlock(&emlrtCoverageInstance, 1U, 4);

  /* % Setup */
  /*  Initialize vars and get some information about the target audio */
  /*  total number of samples in each audio track */
  /*  number of microphones in the array */
  memset(&XSF[0], 0, 14112U * sizeof(real_T));

  /*  initialize shifted track matrix */
  /* % Beamform */
  /*  delaying each microphone track to bring the target signal into alignment */
  /*  then sum all tracks together. */
  /*  d_i = \sqrt{(mpos{i,x}\ ^\_\ s_x)^2+(mpos_{i,y}\ ^\_\ s_y)^2+ */
  /*  (mpos{i,z}\ ^\_\ s_z)^2} \quad i \in [1, M]  */
  /*   \tau_i = f_s\left(\frac{d_{max}\ ^\_\ d_i}{c}\right)  */
  /*  Find the distances of each mic to the source */
  /*  spos*ones: expend one spos to every mpos so as to subtract */
  for (ixstart = 0; ixstart < 3; ixstart++) {
    for (ix = 0; ix < 16; ix++) {
      b_mpos[ixstart + 3 * ix] = mpos[ixstart + 3 * ix] - spos[ixstart];
    }
  }

  power(b_mpos, dv0);
  sum(dv0, b_dist);
  st.site = &ub_emlrtRSI;
  b_sqrt(&st, b_dist);
  for (ixstart = 0; ixstart < 16; ixstart++) {
    dist[ixstart] = (b_dist[ixstart] == 0.0);
  }

  if (covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 7, any(dist))) {
    st.site = &vb_emlrtRSI;
    x_error(&st);
  }

  if (covrtLogIf(&emlrtCoverageInstance, 1U, 0U, 8, iw == 1.0)) {
    covrtLogBasicBlock(&emlrtCoverageInstance, 1U, 5);
    arweights(b_dist, wghts);

    /*  inverse distance weighting */
  } else {
    covrtLogBasicBlock(&emlrtCoverageInstance, 1U, 6);
    for (ixstart = 0; ixstart < 16; ixstart++) {
      wghts[ixstart] = 1.0;
    }

    /*  no weighting */
  }

  covrtLogBasicBlock(&emlrtCoverageInstance, 1U, 7);

  /*  Divide distances by the speed of sound to find duration of travel */
  /*  for each signal.  Take that time relative to the furthest mic, */
  /*  since all other tracks will be delayed to match the wave that */
  /*  took the longest to be recieved. */
  ixstart = 1;
  mtmp = b_dist[0];
  if (muDoubleScalarIsNaN(b_dist[0])) {
    ix = 2;
    exitg1 = false;
    while ((!exitg1) && (ix < 17)) {
      ixstart = ix;
      if (!muDoubleScalarIsNaN(b_dist[ix - 1])) {
        mtmp = b_dist[ix - 1];
        exitg1 = true;
      } else {
        ix++;
      }
    }
  }

  if (ixstart < 16) {
    while (ixstart + 1 < 17) {
      if (b_dist[ixstart] > mtmp) {
        mtmp = b_dist[ixstart];
      }

      ixstart++;
    }
  }

  /*  Convert TDOA to integer delays */
  for (ixstart = 0; ixstart < 16; ixstart++) {
    b_dist[ixstart] = (mtmp - b_dist[ixstart]) / c * fs;
  }

  b_round(b_dist);

  /*  Shift each track.we're recycling x into xPrev on the next iteration */
  /*  take delay amount from xPrev to new xShift windows  */
  k = 0;
  while (k < 16) {
    covrtLogFor(&emlrtCoverageInstance, 1U, 0U, 0, 1);
    covrtLogBasicBlock(&emlrtCoverageInstance, 1U, 8);
    mtmp = ((real_T)xPrev->size[0] - b_dist[k]) + 1.0;
    if (mtmp > xPrev->size[0]) {
      ix = 1;
      ixstart = 1;
    } else {
      if (mtmp != (int32_T)muDoubleScalarFloor(mtmp)) {
        emlrtIntegerCheckR2012b(mtmp, &e_emlrtDCI, sp);
      }

      ixstart = xPrev->size[0];
      ix = (int32_T)mtmp;
      if (!((ix >= 1) && (ix <= ixstart))) {
        emlrtDynamicBoundsCheckR2012b(ix, 1, ixstart, &e_emlrtBCI, sp);
      }

      ixstart = xPrev->size[0];
      i28 = xPrev->size[0];
      if (!((i28 >= 1) && (i28 <= ixstart))) {
        emlrtDynamicBoundsCheckR2012b(i28, 1, ixstart, &e_emlrtBCI, sp);
      }

      ixstart = i28 + 1;
    }

    if (1.0 > 882.0 - b_dist[k]) {
      loop_ub = 0;
    } else {
      mtmp = 882.0 - b_dist[k];
      if (mtmp != (int32_T)muDoubleScalarFloor(mtmp)) {
        emlrtIntegerCheckR2012b(mtmp, &f_emlrtDCI, sp);
      }

      loop_ub = (int32_T)mtmp;
      if (!((loop_ub >= 1) && (loop_ub <= 882))) {
        emlrtDynamicBoundsCheckR2012b(loop_ub, 1, 882, &f_emlrtBCI, sp);
      }
    }

    xPrev_size_idx_0 = (ixstart - ix) + loop_ub;
    b_loop_ub = ixstart - ix;
    for (i28 = 0; i28 < b_loop_ub; i28++) {
      xPrev_data[i28] = xPrev->data[((ix + i28) + xPrev->size[0] * k) - 1];
    }

    for (i28 = 0; i28 < loop_ub; i28++) {
      xPrev_data[(i28 + ixstart) - ix] = x[i28 + 882 * k];
    }

    b_tmp_size[0] = xPrev_size_idx_0;
    for (ixstart = 0; ixstart < xPrev_size_idx_0; ixstart++) {
      b_tmp_data[ixstart] = wghts[k] * xPrev_data[ixstart];
    }

    if (!b1) {
      iv22[0] = 882;
      b1 = true;
    }

    emlrtSubAssignSizeCheckR2012b(iv22, 1, b_tmp_size, 1, &b_emlrtECI, sp);
    memcpy(&XSF[k * 882], &b_tmp_data[0], 882U * sizeof(real_T));
    k++;
    if (*emlrtBreakCheckR2012bFlagVar != 0) {
      emlrtBreakCheckR2012b(sp);
    }
  }

  covrtLogFor(&emlrtCoverageInstance, 1U, 0U, 0, 0);
  covrtLogBasicBlock(&emlrtCoverageInstance, 1U, 9);

  /*  output */
  /*  function dsb */
}

/* End of code generation (delaytracking.c) */
