/*
 * power.c
 *
 * Code generation for function 'power'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "gjbf.h"
#include "power.h"
#include "error1.h"
#include "gjbf_emxutil.h"
#include "scalexpAlloc.h"
#include "gjbf_data.h"
#include "blas.h"

/* Variable Definitions */
static emlrtRSInfo yb_emlrtRSI = { 61, "power",
  "C:\\Program Files\\MATLAB\\R2016a\\toolbox\\eml\\lib\\matlab\\ops\\power.m" };

/* Function Declarations */
static boolean_T b_fltpower_domain_error(void);
static boolean_T fltpower_domain_error(void);

/* Function Definitions */
static boolean_T b_fltpower_domain_error(void)
{
  return false;
}

static boolean_T fltpower_domain_error(void)
{
  return false;
}

void b_power(const emlrtStack *sp, const real_T a_data[], const int32_T a_size[1],
             real_T y_data[], int32_T y_size[1])
{
  int32_T k;
  emlrtStack st;
  emlrtStack b_st;
  emlrtStack c_st;
  st.prev = sp;
  st.tls = sp->tls;
  st.site = &xb_emlrtRSI;
  b_st.prev = &st;
  b_st.tls = st.tls;
  c_st.prev = &b_st;
  c_st.tls = b_st.tls;
  b_st.site = &fd_emlrtRSI;
  c_st.site = &gd_emlrtRSI;
  y_size[0] = (int16_T)a_size[0];
  if (dimagree(y_size, a_size)) {
  } else {
    emlrtErrorWithMessageIdR2012b(&c_st, &u_emlrtRTEI, "MATLAB:dimagree", 0);
  }

  c_st.site = &hd_emlrtRSI;
  for (k = 0; k + 1 <= a_size[0]; k++) {
    y_data[k] = a_data[k] * a_data[k];
  }

  if (fltpower_domain_error()) {
    b_st.site = &yb_emlrtRSI;
    v_error(&b_st);
  }
}

void c_power(const emlrtStack *sp, const emxArray_real_T *a, emxArray_real_T *y)
{
  int32_T n;
  int32_T k;
  emlrtStack st;
  emlrtStack b_st;
  emlrtStack c_st;
  st.prev = sp;
  st.tls = sp->tls;
  st.site = &xb_emlrtRSI;
  b_st.prev = &st;
  b_st.tls = st.tls;
  c_st.prev = &b_st;
  c_st.tls = b_st.tls;
  b_st.site = &fd_emlrtRSI;
  c_st.site = &gd_emlrtRSI;
  n = y->size[0] * y->size[1];
  y->size[0] = (int16_T)a->size[0];
  y->size[1] = 16;
  emxEnsureCapacity(&c_st, (emxArray__common *)y, n, (int32_T)sizeof(real_T),
                    &c_emlrtRTEI);
  if (b_dimagree(y, a)) {
  } else {
    emlrtErrorWithMessageIdR2012b(&c_st, &u_emlrtRTEI, "MATLAB:dimagree", 0);
  }

  n = a->size[0] << 4;
  c_st.site = &hd_emlrtRSI;
  for (k = 0; k + 1 <= n; k++) {
    y->data[k] = a->data[k] * a->data[k];
  }

  if (b_fltpower_domain_error()) {
    b_st.site = &yb_emlrtRSI;
    v_error(&b_st);
  }
}

void power(const real_T a[48], real_T y[48])
{
  int32_T k;
  for (k = 0; k < 48; k++) {
    y[k] = a[k] * a[k];
  }
}

/* End of code generation (power.c) */
