/*
 * wind.c
 *
 * Code generation for function 'wind'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "wind.h"
#include "wind_emxutil.h"
#include "wind_data.h"

/* Variable Definitions */
static emlrtRTEInfo emlrtRTEI = { 1, 26, "wind",
  "E:\\micro array project\\Microphone Array\\beamform test\\wind.m" };

static emlrtDCInfo emlrtDCI = { 9, 11, "wind",
  "E:\\micro array project\\Microphone Array\\beamform test\\wind.m", 1 };

static emlrtDCInfo b_emlrtDCI = { 9, 11, "wind",
  "E:\\micro array project\\Microphone Array\\beamform test\\wind.m", 4 };

static emlrtDCInfo c_emlrtDCI = { 9, 16, "wind",
  "E:\\micro array project\\Microphone Array\\beamform test\\wind.m", 1 };

static emlrtDCInfo d_emlrtDCI = { 9, 16, "wind",
  "E:\\micro array project\\Microphone Array\\beamform test\\wind.m", 4 };

/* Function Definitions */
void wind(const emlrtStack *sp, real_T tWin, real_T fs, real_T nmic, real_T
          *nWin, real_T *nInc, emxArray_real_T *inx)
{
  real_T y;
  real_T b_y;
  int32_T i0;
  real_T d0;
  int32_T loop_ub;
  covrtLogFcn(&emlrtCoverageInstance, 0U, 0);
  covrtLogBasicBlock(&emlrtCoverageInstance, 0U, 0);
  *nWin = muDoubleScalarRound(tWin * fs);

  /*  Audio window size in samples */
  y = *nWin / 2.0;
  if (y < 0.0) {
    b_y = muDoubleScalarCeil(y);
  } else {
    b_y = muDoubleScalarFloor(y);
  }

  if (covrtLogIf(&emlrtCoverageInstance, 0U, 0U, 0, *nWin / 2.0 != b_y)) {
    covrtLogBasicBlock(&emlrtCoverageInstance, 0U, 1);

    /*  Ensure samples are even for overlap and add */
    (*nWin)++;
  }

  covrtLogBasicBlock(&emlrtCoverageInstance, 0U, 2);
  *nInc = muDoubleScalarRound(*nWin / 2.0);

  /*  Window increment %50 overlap */
  /*  hWin=repmat(hWin,1,nmic); % repeat to match number mic */
  i0 = inx->size[0] * inx->size[1];
  d0 = *nWin;
  if (!(d0 >= 0.0)) {
    emlrtNonNegativeCheckR2012b(d0, &b_emlrtDCI, sp);
  }

  if (d0 != (int32_T)muDoubleScalarFloor(d0)) {
    emlrtIntegerCheckR2012b(d0, &emlrtDCI, sp);
  }

  inx->size[0] = (int32_T)d0;
  if (!(nmic >= 0.0)) {
    emlrtNonNegativeCheckR2012b(nmic, &d_emlrtDCI, sp);
  }

  d0 = nmic;
  if (d0 != (int32_T)muDoubleScalarFloor(d0)) {
    emlrtIntegerCheckR2012b(d0, &c_emlrtDCI, sp);
  }

  inx->size[1] = (int32_T)d0;
  emxEnsureCapacity(sp, (emxArray__common *)inx, i0, (int32_T)sizeof(real_T),
                    &emlrtRTEI);
  d0 = *nWin;
  if (!(d0 >= 0.0)) {
    emlrtNonNegativeCheckR2012b(d0, &b_emlrtDCI, sp);
  }

  if (d0 != (int32_T)muDoubleScalarFloor(d0)) {
    emlrtIntegerCheckR2012b(d0, &emlrtDCI, sp);
  }

  if (!(nmic >= 0.0)) {
    emlrtNonNegativeCheckR2012b(nmic, &d_emlrtDCI, sp);
  }

  y = nmic;
  if (y != (int32_T)muDoubleScalarFloor(y)) {
    emlrtIntegerCheckR2012b(y, &c_emlrtDCI, sp);
  }

  loop_ub = (int32_T)d0 * (int32_T)y;
  for (i0 = 0; i0 < loop_ub; i0++) {
    inx->data[i0] = 0.0;
  }

  /*  initial window  */
}

/* End of code generation (wind.c) */
